RPL
INCLUDE Atmos.h

* $EXTPRG. Needed to be xNAME because otherwise calling the library with 1298 MENU
* would bring up an empty menu.
xNAME Atmos
::
		ERRSET :: CK1NOLASTWD DUPTYPEBINT? NOT_IT MenuBuilder  ;
  ERRTRAP :: MenuBuilder	;
		# 512 OVER#=case :: MenuBuilder	;
;

*Menu builder. Needed to handle left/right shift for T and M,TAS and to have the
*  commands conveniently separated in 3 pages.
NULLNAME MenuBuilder
::
  ( Page 1: geometric computations)
  { "H"   ::	CHKARG_HEIGHT H HTPRho_FullPostprocess	;		}
  { "T"   { :: CHKARG_TEMPERATURE T2H_Mid HTPRho_FullPostprocess $ "T 'Mid altitude' Solution"  DispInStatusArea ;
		          :: CHKARG_TEMPERATURE T2H_Inf HTPRho_FullPostprocess $ "T 'Low altitude' Solution"  DispInStatusArea ;
												:: CHKARG_TEMPERATURE T2H_Sup HTPRho_FullPostprocess $ "T 'High altitude' Solution"  DispInStatusArea ; } }
  { "P"   :: CHKARG_PRESS P2H HTPRho_FullPostprocess ; }
  { "\97" :: CHKARG_DENSITY Rho2H HTPRho_FullPostprocess ; }
  { "v" :: CHKARG_KINVISC Nu2H HTPRho_FullPostprocess ; }
  { "g" :: CHKARG_ACC g2H HTPRho_FullPostprocess ; }
  ( Page 2: velocity computations )
  { "H,CAS" :: CHK2ARGS_HSPEED H_VCAS HSPEED_FullPostprocess ; }
  { "H,EAS" :: CHK2ARGS_HSPEED H_VEAS HSPEED_FullPostprocess ; }
  { "H,TAS" :: CHK2ARGS_HSPEED H_VTAS HSPEED_FullPostprocess ; }
  { "H,M"   :: CHK2ARGS_HMACH H_Mach HSPEED_FullPostprocess ; }
  { "H,q"  :: CHK2ARGS_HDYNPRESS H_qEAS HSPEED_FullPostprocess ; }
  NULL{}
  ( Page 3: kink altitude computations )
  { "M,CAS" :: CHK2ARGS_MSPEED M_VCAS MSPEEDq_FullPostprocess ; }
  { "M,EAS" :: CHK2ARGS_MSPEED M_VEAS MSPEEDq_FullPostprocess ; }
  { "M,TAS" { :: CHK2ARGS_MSPEED M_VTAS_Mid MSPEEDq_FullPostprocess $ "Mid altitude intersection"  DispInStatusArea ;
		            :: CHK2ARGS_MSPEED M_VTAS_Inf MSPEEDq_FullPostprocess $ "Lower altitude intersection\0ADefault for airspeed diagrams"  DispInStatusArea ;
														:: CHK2ARGS_MSPEED M_VTAS_Sup MSPEEDq_FullPostprocess $ "Higher altitude intersection"  DispInStatusArea ; } }
  { "M,q"   :: CHK2ARGS_MDYNPRESS M_q MSPEEDq_FullPostprocess ; }

		SIXTEEN {}N
  DoMenuKey
;



**********************************************************************
*                   U T I L I T Y     R O U T I N E S                *
**********************************************************************

*Returns TRUE if User Flag 60 is set, FALSE otherwise
* STACK DIAGRAM
* ( -> TRUE/FALSE )
NULLNAME EnglishUnits?
:: SIXTY TestUserFlag ;

*Bind the contants used by the program to NULL LAMS
* 15GETLAM : kinematic viscosity array in m/s
* 14GETLAM : value of B in Sutherland's law in K
* 13GETLAM : value of A in Sutherland's law in kg/(m*s*sqrt(K))
* 12GETLAM : acceleration of gravity at sea level
* 11GETLAM : R for air
* 10GETLAM : kappa = Cp/Cv for air
*  9GETLAM : Density ratios array
*  8GETLAM : Altitudes array in m
*  7GETLAM : Temperature gradients array in K/m
*  6GETLAM : Temperatures array in K             (values for the lower bound of each atmospheric band)
*  5GETLAM : Pressure ratios array
*  4GETLAM : Pressure at sea level in Pa
*  3GETLAM : Density at sea level in kg/m
*  2GETLAM : Earth radius in m
*  1GETLAM : GMR
NULLNAME BINDCONSTS
::
		% 110.4 ( value of B in Sutherland's law )
		% 1.458E-6 ( value of A in Sutherland's law )
  % 9.80665 ( acceleration of gravity at sea level )
		% 287.06 ( R for air )
  % 1.4 ( kappa = Cp/Cv for air )
*  { %1 % 2.97075940144E-1 % 7.18651953546E-2 % 1.07959255160E-2 % 1.16533346591E-3 % 7.03351433672E-4 % 5.24171681355E-5 % 5.67990486139E-6 } ( density ratios)
  { %0 % 11E3 % 20E3 % 32E3 % 47E3 % 51E3 % 71E3 % 84.852E3 } ( Altitudes array in m )
  { % -6.5E-3 %0 % 1E-3 % 2.8E-3 %0 % -2.8E-3 % -2E-3 %0 }     ( Temperature gradients array in K/m )
  { % 288.15 % 216.65 % 216.65 % 228.65 % 270.65 % 270.65 % 214.65 % 186.946 } ( Base temperatures array in K )
  ( Retrieves the Non Standard Day Temperature deviation and sums it to the base temperatures)
  ( This way it is going to be much easier to compute any quantity even for Non Standard Day, since all the procedures will be still valid!)
  CKDeltaT_NSD %CHS x- ( Change_sign & Subtraction are used to add DeltaT to the base temperature array,
		                       since x+ produces an augmented list, it does not add the number to all list's elements)
  
  { %1 % 2.23361105092E-1  % 5.40329501078E-2 % 8.56667835929E-3 % 1.09456013378E-3 % 6.60635313286E-4 % 3.90468337334E-5 % 3.68500952357E-6 } ( Pressures base ratio array)
  
  ( Computes the base density ratios)
  DUP 3PICK DUP
  ONE NTHCOMPDROP
  x/ x/
		( Puts it on the 5th level of the stack: compatibility with the other procedures from Atmos 1.0)
  5UNROLL

  % 101325    ( Pressure at sea level in Pa; it would be more laborious and would require more bytes to use the built-in constant)
  % 1.225     ( Density at sea level in kg/m )
  % 6378137   ( Earth radius in m )
  % 34.163194736310E-3 ( hydrostatic constant = gravity * air molar weight / gas constant [the latter as defined in USSA1976] )

		6PICK %3 %2 %/ x^ FOURTEEN PICK x* 7PICK SIXTEEN PICK %CHS x- 5PICK x* 11 PICK x* x/
		FIFTEEN UNROLL

  NULLLAM FIFTEEN NDUPN DOBIND
;

*Checks the content of a variable \DeltaTNSD and put its value (converted
*  to Kelvin) on the stack
* STACK DIAGRAM
* ( -> % [DeltaT_NSD value in Kelvin] )
NULLNAME CKDeltaT_NSD
::
  ' ID \9BTNSD @ ( search for variable \DeltaTNSD in current path and recall its content)
  NOT ITE ::     ( if not found, then assumes that there is no deviation of the temperature from the standard day)
    %0
  ;
  :: ( if found, try to convert it to Kelvin and put it on stack)
    ERRSET :: ( if an error will occur, execution continues @ ERRTRAP)

      :: ( check for type of the content of the variable \DeltaTNSD, stripping tags and converting zints to reals)
      CK&DISPATCH1
      real   FALSE
      unitob TRUE ( put TRUE on the stack)
      id     :: ONE SYMBN RunInApprox CRUNCH FALSE ; ( build a symbolic and evaluates it)
      symb   :: RunInApprox CRUNCH FALSE ;
      seco   :: RunInApprox CRUNCH FALSE ;
      ;
      ( if the CHK&DISPATCH before returned TRUE, then the content of \DeltaTNSD is a unit)
      ITE ::
        %0 OVER UM>U ( build the reference, i.e. 0, temperature in the unit in which the \DeltaTNSD is expressed)
        UNIT %1 "K" umEND ; UMCONV ( try to convert to kelvin, errors if the unit is invalid)
        U>nbr ( put the number part of the reference temperature on level 1)
        SWAP
        UNIT %1 "K" umEND ; UMCONV ( try to convert to kelvin the temperature itself sotred under \DeltaTNSD, errors if the unit is invalid)
        U>nbr ( put the number part of the unit on level 1)
        SWAP %- ( subtract the temperature in \DeltaTNSD from the reference one, once they are expressed both in Kelvin)
      ;
      ::  ( If the object is a number )
			     EnglishUnits? IT ( If User Flag 60 is set = English units )
				    :: ( the number is to be interpreted as a temperature in degrees Rankine )
				      %>%% cfF %%* %%>% ( convert it to Kelvin )
				    ;
      ;
    ;
    ERRTRAP :: ( if an error occurs, it means that the content of the \DeltaTNSD variable is invalid: ask the user to purge it)
               ( note that the stack will be restored thanks to the CK1NOLASTWD in CHKARG invoked at the beginning from any command of the library)
      $ "Bad \9BTNSD var. Purge?" AskQuestion
      ( Display error messages according to the answer )
      ITE :: DROP ' ID \9BTNSD PURGE $ "\9BTNSD variable purged" EXITMSGSTO #70000 ERROROUT ; ( If answer Yes, purges it and errors)
      :: $ "Current content of \9BTNSD: " ID \9BTNSD DO>STR &$ EXITMSGSTO #70000 ERROROUT ; ( If answer is No, puts on stack level 1 the tagged current Gamma var)
    ;
  ;
;



**********************************************************************
*           P R E P R O C E S S I N G     R O U T I N E S            *
*                                                                    *
* Called before computing to perform:                                *
*   - Arguments checking and conversion of their value to SI Units   *
*   - Inputs repackaging (Page3 functions only)                      *
*                                                                    *
**********************************************************************

*************************************
* INPUT ARGUMENTS CHECKING ROUTINES *
*************************************

*Check if argument in level 1 is valid
* STACK DIAGRAM
* ( unit            -> unit TRUE  )
* ( %|ID|symb|prog| -> %    FALSE )
* ( other           -> other      ) + ERROR
NULLNAME CHKARG
::
  BINDCONSTS ( Create the constants; we do it here only because each routine calls this one at the beginning)
  CK1NOLASTWD
  CK&DISPATCH1 ( check for type, stripping tags and converting zints to reals)
    real   FALSE
    unitob TRUE ( put TRUE on the stack)
    id     :: ONE SYMBN RunInApprox CRUNCH FALSE ; ( build a symbolic and evaluates it)
    symb   :: RunInApprox CRUNCH FALSE ;
    seco   :: RunInApprox CRUNCH FALSE ;
;

*Check if argument in level 1 is a valid length
* STACK DIAGRAM
* ( %|%_length -> %     )
* ( other      -> other ) + ERROR
NULLNAME CHKARG_HEIGHT
::
		CHKARG ( Check if object in level 1 is valid )
  ITE ( If the object is a unit object )
		::
    UNIT %1 "m" umEND ; UMCONV ( try to convert to metres, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as a length in feet )
				  % 0.3048 %* ( convert it to meters )
				;
  ;
;

*Check if argument in level 1 is a valid temperature
* STACK DIAGRAM
* STACK DIAGRAM
* ( %|%_temp. -> %     )
* ( other     -> other ) + ERROR
NULLNAME CHKARG_TEMPERATURE
::
  CHKARG ( Check if object in level 1 is valid )
  ITE :: ( If the object is a unit object )
    UNIT %1 "K" umEND ; UMCONV ( try to convert to kelvin, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as a temperature in degrees Rankine )
				  %>%% cfF %%* %%>% ( convert it to Kelvin )
				;
  ;
  DUP %0 %<= IT :: SETSIZEERR ; ( Check if greater than zero)
;

*Check if arguments in level 1 is a valid speed
*Used by CHK2ARGS_HSPEED, CHK2ARGS_MSPEED
* STACK DIAGRAM
* ( %|%_speed -> %     )
* ( other     -> other ) + ERROR
NULLNAME CHKARG_SPEED
::
  CHKARG ( Check if object in level 1 is valid )
  ITE :: ( If the object is a unit object )
    UNIT %1 "m" "s" um/ umEND ; UMCONV ( try to convert to m/s, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as a speed in knots )
				  % 0.514444444444 %* ( convert it to meters/second )
				;
  ;
  DUP %0 %<= IT :: SETSIZEERR ; ( Check if greater than zero)
;

*Check if arguments in level 1 is a valid acceleration
* STACK DIAGRAM
* ( %|%_acc. -> %     )
* ( other    -> other ) + ERROR
NULLNAME CHKARG_ACC
::
  CHKARG ( Check if object in level 1 is valid )
  ITE :: ( If the object is a unit object )
    UNIT %1 "m" "s" %2 um^ um/ umEND ; UMCONV ( try to convert to m/s, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as an acceleration in ft/s )
				  % 0.3048 %* ( convert it to m/s )
				;
  ;
  DUP %0 %<= IT :: SETSIZEERR ; ( Check if greater than zero)
;

*Check if arguments in level 1 is a valid pressure
*Used also by CHK2ARGS_HDYNPRESS
* STACK DIAGRAM
* ( %|%_press. -> %     )
* ( other      -> other ) + ERROR
NULLNAME CHKARG_PRESS
::
  CHKARG ( Check if object in level 1 is valid )
  ITE :: ( If the object is a unit object )
    UNIT %1 "Pa" umEND ; UMCONV ( try to convert to Pa, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as a speed in psi )
				  % 6894.75729317 %* ( convert it to Pascal )
				;
  ;
  DUP %0 %<= IT :: SETSIZEERR ; ( Check if greater than zero)
;

*Check if arguments in level 1 is a valid density
* STACK DIAGRAM
* ( %|%_dens. -> %     )
* ( other     -> other ) + ERROR
NULLNAME CHKARG_DENSITY
::
  CHKARG ( Check if object in level 1 is valid )
  ITE :: ( If the object is a unit object )
    UNIT %1 CHR \6B "g" umP "m" %3 um^ um/ umEND ; UMCONV ( try to convert to kg/m, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as a density in slugs/ft )
				  % 515.378818393 %* ( convert it in Kg/m )
				;
  ;
  DUP %0 %<= IT :: SETSIZEERR ; ( Check if greater than zero)
;

*Check if arguments in level 1 is a valid kinematic viscosity
* STACK DIAGRAM
* ( %|%_kin.visc. -> %     )
* ( other         -> other ) + ERROR
NULLNAME CHKARG_KINVISC
::
  CHKARG ( Check if object in level 1 is valid )
  ITE :: ( If the object is a unit object )
    UNIT %1 "m" %2 um^ "s" um/ umEND ; UMCONV ( try to convert to m/s, errors if the unit is invalid)
     U>nbr ( put the number part of the unit on level 1)
  ;
  ::  ( If the object is a number )
			 EnglishUnits? IT ( If User Flag 60 is set = English units )
				:: ( the number is to be interpreted as a kinematic viscosity in ft/s )
				  % 0.3048 %SQ_ %* ( convert it in m/s )
				;
  ;
  DUP %0 %<= IT :: SETSIZEERR ; ( Check if greater than zero)
;

*Check if arguments in level 1 and 2 are valid length and speed
*Used together with H_VCAS, H_VEAS, H_VTAS
* STACK DIAGRAM
* ( %1|%1_length %2|%2_speed -> %1 %2 )
* ( other                    -> other ) + ERROR
NULLNAME CHK2ARGS_HSPEED
::
  CK2NOLASTWD
  CHKARG_SPEED
  SWAP
  CHKARG_HEIGHT ( check if the height is espressed in valid units)
  SWAP
;

*Check if arguments in level 1 and 2 are valid length and pressure
* STACK DIAGRAM
* STACK DIAGRAM
* ( %1|%1_length %2|%2_press. -> %1 %2 )
* ( other                     -> other ) + ERROR
NULLNAME CHK2ARGS_HDYNPRESS
::
  CK2NOLASTWD
  CHKARG_PRESS
  SWAP
  CHKARG_HEIGHT ( check if the height is espressed in valid units)
  SWAP
;

*Check if arguments in level 1 and 2 are valid length and number
* STACK DIAGRAM
* ( %1|%1_length %2 -> %1 %2 )
* ( other           -> other ) + ERROR
NULLNAME CHK2ARGS_HMACH
::
  CK2NOLASTWD
  CHKARG ( Check if object in level 1 is valid; if TRUE is returned, it has a unit: impossible!!! It must be a mach number!!! )
  IT :: SETTYPEERR ;
  SWAP
  CHKARG_HEIGHT ( check if the height is espressed in valid units)
		SWAP
;

*Check if arguments in level 1 and 2 are valid number and speed
* STACK DIAGRAM
* ( %1 %2|%2_speed -> %1 %2 )
* ( other          -> other ) + ERROR
NULLNAME CHK2ARGS_MSPEED
::
  CK2NOLASTWD
  CHKARG_SPEED ( Check if object in level 1 is a valid speed)
  SWAP   ( Put Mach on level 1)
  CHKARG ( Check if object in level 1 is valid; if TRUE is returned, it has a unit: impossible!!! It must be a mach number!!! )
  IT :: SETTYPEERR ;
  SWAP
;

*Check if arguments in level 1 and 2 are valid
*Used together with M_q
* STACK DIAGRAM
* ( %1 %2|%2_press. -> %1 %2 )
* ( other           -> other ) + ERROR
NULLNAME CHK2ARGS_MDYNPRESS
::
  CK2NOLASTWD
  CHKARG_PRESS ( Check if object in level 1 is a valid speed)
  SWAP   ( Put Mach on level 1)
  CHKARG ( Check if object in level 1 is valid; if TRUE is returned, it has a unit: impossible!!! It must be a mach number!!! )
  IT :: SETTYPEERR ;
  SWAP
;




**********************************************************************
*          P O S T P R O C E S S I N G     R O U T I N E S           *
*                                                                    *
* Called after actual computations to perform:                       *
*   - Units adding (remember that internally Atmos computes          *
*                  everything without units; numbers represent       *
*                  quantities normalized according to the SI system) *
*   - Name Tagging                                                   *
*   - Additional info displaying                                     *
*                                                                    *
**********************************************************************

* Wrapper function for Page1 functions post-process
NULLNAME HTPRho_FullPostprocess
::
  EnglishUnits? ITE ( If User Flag 60 is set = English units )
		  HTPRho_ImperialUnits ( add SI units )
		  HTPRho_SIUnits ( add Imperial units )
	 TAG_HTPRho ( tag the quantities )
;

* Attach the SI units to the computed quantities
* STACK DIAGRAM
* ( %H %T %P %Rho %Nu %g -> H_m T_K P_Pa Rho_kg/m Nu_m/s g_m/s)
NULLNAME HTPRho_SIUnits
::
		"m" "s" %2 um^ um/ umEND BINT7 EXTN ( g )
		6UNROLL
		"m" %2 um^ "s" um/ umEND BINT7 EXTN ( Nu )
  6UNROLL
  CHR \6B "g" umP "m" %3 um^ um/ umEND BINT9 EXTN ( Rho )
  6UNROLL
  "Pa" umEND BINT3 EXTN ( P )
  6UNROLL
  "K" umEND BINT3 EXTN ( T )
  6UNROLL
  "m" umEND BINT3 EXTN ( H )
  6UNROLL
;
* Convert the computed quantities in the imperial system and attach the relative units
* STACK DIAGRAM
* ( %H %T %P %Rho %Nu %g -> H_ft T_R P_psi Rho_slug/ft Nu_ft/s g_ft/s )
NULLNAME HTPRho_ImperialUnits
::
  % 0.3048 %/ "ft" "s" %2 um^ um/ umEND BINT7 EXTN ( g )
	 6UNROLL
		% 0.3048 %SQ_ %/ "ft" %2 um^ "s" um/ umEND BINT7 EXTN ( Nu )
  6UNROLL
  % 515.378818393 %/ "slug" "ft" %3 um^ um/ umEND BINT7 EXTN ( Rho )
  6UNROLL
  % 6894.75729317 %/ "psi" umEND BINT3 EXTN ( P )
  6UNROLL
  %>%% cfF %%/ %%>% "R" umEND BINT3 EXTN ( T )
  6UNROLL
  % 0.3048 %/ "ft" umEND BINT3 EXTN ( H )
  6UNROLL
;
* STACK DIAGRAM
* ( H T P Rho Nu g -> H:H T:T P:P Rho:Rho v:Nu g:g )
NULLNAME TAG_HTPRho
:: { "H" "T" "P" "\97" "v" "g" } TAGOBS ;


* Wrapper function for Page2 functions post-process
NULLNAME HSPEED_FullPostprocess
::
  EnglishUnits? ITE ( If User Flag 60 is set = English units )
		  HSPEED_ImperialUnits ( add SI units )
		  HSPEED_SIUnits ( add Imperial units )
	 TAG_HSPEED ( tag the quantities )
;
* Attach the SI units to the computed quantities
* STACK DIAGRAM
* ( %H %VCAS %VEAS %VTAS %M %q %Re/m -> H_m VCAS_m/s VEAS_m/s VTAS_m/s %M q_Pa Re/m_1/m )
NULLNAME HSPEED_SIUnits
::
  %1 "m" um/ umEND BINT5 EXTN
  7UNROLL
  "Pa" umEND BINT3 EXTN
  7UNROLL
  7UNROLL ( Mach)
  "m" "s" um/ umEND BINT5 EXTN
  7UNROLL
  "m" "s" um/ umEND BINT5 EXTN
  7UNROLL
  "m" "s" um/ umEND BINT5 EXTN
  7UNROLL
  "m" umEND BINT3 EXTN
  7UNROLL
;		
* Convert the computed quantities in the imperial system and attach the relative units
* STACK DIAGRAM
* ( %H %VCAS %VEAS %VTAS %M %q %Re/m -> H_ft VCAS_ft/s VEAS_ft/s VTAS_ft/s %M q_Pa Re/m_1/m )
NULLNAME HSPEED_ImperialUnits
::
  % 0.3048 %/ %1 "ft" um/ umEND BINT5 EXTN
  7UNROLL
  % 6894.75729317 %/ "psi" umEND BINT3 EXTN
  7UNROLL
  7UNROLL ( Mach)
  % 0.514444444444 %/ "knot" umEND BINT3 EXTN
  7UNROLL
  % 0.514444444444 %/ "knot" umEND BINT3 EXTN
  7UNROLL
  % 0.514444444444 %/ "knot" umEND BINT3 EXTN
  7UNROLL
  % 0.3048 %/ "ft" umEND BINT3 EXTN
		7UNROLL
;		
* STACK DIAGRAM
* ( H V_CAS V_EAS V_TAS M q Re/m -> H:H VCAS:VCAS VEAS:VEAS VTAS:VTAS M:M q:q Re/m:Re/m )
NULLNAME TAG_HSPEED
:: { "H" "VCAS" "VEAS" "VTAS" "M" "q" "Re/m" } TAGOBS ;


* STACK DIAGRAM
* ( %H %T %P %Rho %Nu -> H:%H_unit )
NULLNAME MSPEEDq_FullPostprocess
::
  5DROP ( Drop everything else but the altitude)
  EnglishUnits? ITE ( If User Flag 60 is set = English units )
		  :: % 0.3048 %/ "ft" umEND BINT3 EXTN ; ( convert to Imperial unit and add it )
		  :: "m" umEND BINT3 EXTN ; (  add SI units )
  { "H" } TAGOBS ( tag the altitude )
;

* Display messages at the top of the screen
* UNcomment these lines for HP49G
*NULLNAME DispInStatusArea
*::
*  ClrDA1IsStat
*  $>grobCR  ( Converts the string in a grob using minifont)
*  INVGROB
*  ZEROZERO ROT ( Displays the information on the top-left corner of the screen)
*  XYGROBDISP SetDA1NoCh ( Displays it and freeze the header)
*;
* UNcomment these lines for HP49G+
NULLNAME DispInStatusArea
::
  ClrDA1IsStat
  $>grobCR  ( Converts the string in a grob using minifont)
  INVGROB
  BINT16 BINT131 MAKEGROB ( Makes a blank GROB 16x131)
  SWAP ZEROZERO TRUE 5UNROLL GROB+#
  Rest16Patch_ SetDA1Temp ( Displays it and freezes the header)
;
