RPL
INCLUDE Atmos.h

**********************************************************************
* Kink Altitudes related functions

* STACK DIAGRAM
* ( %M %VCAS %M VCAS_unit -> M:%M  VCAS:%VCAS_unit %H %T %P %Rho %Nu %g )
NULLNAME M_VCAS
::
  MSPEED_RepackageInputs
		{ "M" "VCAS" } TAGOBS        ( tag the inputs)
  4UNROLL 4UNROLL   ( Put tagged Mach and speed on top)

		( Compute qc/P0+1 from the VCAS )
  VCAS2qc/P0+1 %1- 4GETLAM ( P0 ) %*
  SWAP
  ( Compute qc/P from Mach )
		Mach2qc/P

		%/
  
  P2H ( Computes the altitude)
;

* STACK DIAGRAM
* ( %M %VEAS %M VEAS_unit -> M:%M  VEAS:%VEAS_unit %H %T %P %Rho %Nu %g )
NULLNAME M_VEAS
::
  MSPEED_RepackageInputs
		{ "M" "VEAS" } TAGOBS        ( tag the inputs)
  4UNROLL 4UNROLL   ( Put Mach and speed on top)
  
		SWAP %/ %SQ_ 10GETLAM ( kappa ) %/ 3GETLAM ( rho0 ) %* ( Computes the pressure)
   
  P2H ( Computes the altitude)
;

* STACK DIAGRAM
* ( %M %VTAS %M VTAS_unit -> M:%M  VTAS:%VTAS_unit %H %T %P %Rho %Nu )
NULLNAME M_VTAS_Inf
::
  M_VTAS_COMMON
  T2H_Inf ( Computes the altitude, aiming for the lower kink)
;
* STACK DIAGRAM
* ( %M %VTAS %M VTAS_unit -> M:%M  VTAS:%VTAS_unit %H %T %P %Rho %Nu )
NULLNAME M_VTAS_Mid
::
  M_VTAS_COMMON
  T2H_Mid ( Computes the altitude, aiming for the mid kink)
;
* STACK DIAGRAM
* ( %M %VTAS %M VTAS_unit -> M:%M  VTAS:%VTAS_unit %H %T %P %Rho %Nu )
NULLNAME M_VTAS_Sup
::
  M_VTAS_COMMON
  T2H_Sup ( Computes the altitude, aiming for the higher kink)
;
* STACK DIAGRAM
* ( %M %VTAS %M VTAS_unit -> M:%M  VTAS:%VTAS_unit %T )
NULLNAME M_VTAS_COMMON
::
  MSPEED_RepackageInputs
		{ "M" "VTAS" } TAGOBS        ( tag the inputs)
  4UNROLL 4UNROLL   ( Put Mach and speed on top)
  
  SWAP %/ %SQ_ 10GETLAM ( Gamma ) %/ 11GETLAM ( R_Air ) %/ ( Computes the temperature)
;

* STACK DIAGRAM
* ( %M %q %M q_unit -> M:%M  q:%q_unit %H %T %P %Rho %Nu %g )
NULLNAME M_q
::
  MDYNPRESS_RepackageInputs
		{ "M" "q" } TAGOBS   ( tag the inputs)
  4UNROLL 4UNROLL   ( Put Mach and dyn pressure on top)
  
  %2 %* 3GETLAM ( rho0) %/ %SQRT ( Computes V_EAS)
		SWAP %/ %SQ_ 10GETLAM ( kappa ) %/ 3GETLAM ( rho0 ) %* ( Computes the pressure)

  P2H ( Computes the altitude)
;

*****************************************************
* INPUTS REPACKAGING ROUTINES (Page3 commands only) *
*****************************************************

*Repackages the input Mach number and Speed before the functions
*M_VCAS, M_VEAS, M_VTAS_Mid, M_VTAS_Inf, M_VTAS_Sup are called
* STACK DIAGRAM
* ( %M %speed -> %M %speed %M speed_unit )
NULLNAME MSPEED_RepackageInputs
::
  2DUP ( duplicates the inputs translated to SI units)
  EnglishUnits? ITE ( If User Flag 60 is set = English units )
		  :: % 0.514444444444 %/ "knot" umEND BINT3 EXTN ; ( convert to Imperial units and add them )
		  :: "m" "s" um/ umEND BINT5 EXTN ; (  add SI units )
;

*Repackages the input Mach number and Dynamic Pressure before the
*function M_q is called
* STACK DIAGRAM
* ( %M %q -> %M %q %M q_unit )
NULLNAME MDYNPRESS_RepackageInputs
::
  2DUP ( duplicates the inputs translated to SI units)
  EnglishUnits? ITE ( If User Flag 60 is set = English units )
		  :: % 6894.75729317 %/ "psi" umEND BINT3 EXTN ; ( convert to Imperial unit and add it )
		  :: "Pa" umEND BINT3 EXTN ; (  add SI units )
;
