**********************************************************************
*                                                                    *
*INCLUDE THIS FILE IN THE BUILD ONLY IF YOU WANT TO TEST THE LIBRARY!*
*                                                                    *
* Ensure Flag +60 is clear (Metric units) when running the tests.    *
*                                                                    *
**********************************************************************

RPL
INCLUDE Atmos.h

* Tests for Page1 commands
* A list per altitude is produced, computing quantities using all quantities as inputs
xNAME Page1_test
::
	 %0 CHKARG DROP     ( call CHKARG+DROP to initialize the LAMs)
		            H      ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Inf      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)


		% 1000 %CHS H      ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Inf      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

		
		% 5000 H           ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Inf      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 10000 H          ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Inf      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 15000 H          ( compute values from H )   ( REMEMBER TROPOPAUSE: T = cost!!!!! )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Inf      ( compute values from T )
	 5PICK T2H_Mid      ( compute values from T )
	 # 2B #1-{}N        ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 30000 H          ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Mid      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 40000 H          ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Mid      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 50000 H          ( compute values from H )   ( REMEMBER STRATOPAUSE: T = cost!!!!! )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Mid      ( compute values from T )
	 5PICK T2H_Sup      ( compute values from T )
	 # 2B #1-{}N        ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 60000 H          ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Sup      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 80000 H          ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Sup      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the second decimal digit to ease inspection)

	
		% 100000 H         ( compute values from H )
	 Compute_from_P_Rho_Nu_g
	 5PICK T2H_Sup      ( compute values from T )
	 THIRTYSEVEN #1-{}N ( Compose a list of all computed stuff for H = 0 )
	                    ( By inspection it will be verified if tehre are any problems)
	 %8 xRND            ( Round to the eight decimal digit to ease inspection)
;
* Recompute all Page 1 quantities using as input the already outputted P, Rho, Nu and g
NULLNAME Compute_from_P_Rho_Nu_g
::
		4PICK P2H
		3PICK Rho2H
		OVER  Nu2H
		DUP   g2H
;


* Tests for Page2 commands
* A list per altitude/CAS combination is produced, computing quantities using all quantities as inputs
xNAME Page2_test
::
	 %0 %10 CHKARG DROP     ( call CHKARG+DROP to initialize the LAMs)
		            H_VCAS     ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
		%0 % 100    H_VCAS     ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 %0 % 300    H_VCAS     ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 %0 % 500    H_VCAS     ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 %0 % 700    H_VCAS     ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS

		% 1000 %CHS %10   H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 1000 %CHS % 100 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 1000 %CHS % 300 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 1000 %CHS % 500 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 1000 %CHS % 700 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
		
		% 10000 %10   H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 10000 % 100 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 10000 % 300 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 10000 % 500 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 10000 % 700 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	
		% 15000 %10   H_VCAS ( compute values from H & VCAS ) ( REMEMBER TROPOPAUSE: T = cost!!!!! )
	 Compute_from_EAS_TAS_M_qEAS
	 % 15000 % 100 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 15000 % 300 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 15000 % 500 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 15000 % 700 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	
		% 30000 %10   H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 30000 % 100 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 30000 % 300 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 30000 % 500 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 30000 % 700 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS

		% 50000 %10   H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
  % 50000 % 100 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 50000 % 300 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 50000 % 500 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
	 % 50000 % 700 H_VCAS ( compute values from H & VCAS )
	 Compute_from_EAS_TAS_M_qEAS
;
* Recompute all Page 2 quantities using as input the already outputted VEAS, VTAS, Mach and q
NULLNAME Compute_from_EAS_TAS_M_qEAS
::
		7PICK 6PICK H_VEAS
		7PICK 5PICK H_VTAS
		7PICK 4PICK H_Mach
		7PICK 3PICK H_qEAS
	 THIRTYSIX #1-{}N ( Compose a list of all computed stuff for this combination of altitude and CAS)
	                  ( By inspection it will be verified if there are any problems)
	 %4 xRND          ( Round to the fourth decimal digit to ease inspection)
;

* Tests for Page3 commands
* A list per Mach/CAS combination is produced, computing quantities using all quantities as inputs
xNAME Page3_test
::
		% 0.2 % 40 CHKARG DROP  ( call CHKARG+DROP to initialize the LAMs)
		            M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.2 % 50  M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.2 % 60  M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		
		% 0.3 % 50  M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.3 % 60  M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.3 % 70  M_VCAS      ( compute values from H & VCAS )
  Recompute_M_CAS
  
		% 0.4 % 70  M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.4 % 80  M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.4 % 100 M_VCAS      ( compute values from H & VCAS )
  Recompute_M_CAS
  
		% 0.7 % 100 M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.7 % 120 M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 0.7 % 140 M_VCAS      ( compute values from H & VCAS )
  Recompute_M_CAS

		%1 % 140 M_VCAS         ( compute values from H & VCAS )
		Recompute_M_CAS
		%1 % 180 M_VCAS         ( compute values from H & VCAS )
		Recompute_M_CAS
		%1 % 220 M_VCAS         ( compute values from H & VCAS )
  Recompute_M_CAS

		% 1.2 % 140 M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 1.2 % 180 M_VCAS      ( compute values from H & VCAS )
		Recompute_M_CAS
		% 1.2 % 220 M_VCAS      ( compute values from H & VCAS )
  Recompute_M_CAS

		%2 % 200 M_VCAS         ( compute values from H & VCAS )
		Recompute_M_CAS
		%2 % 240 M_VCAS         ( compute values from H & VCAS )
		Recompute_M_CAS
		%2 % 280 M_VCAS         ( compute values from H & VCAS )
  Recompute_M_CAS
;

* Recompute all Page 2 quantities using as input the already outputted VEAS, VTAS, Mach and q
NULLNAME Recompute_M_CAS
::
		5DROP ( drop the quantities comptued together with the altitude)
		OVER STRIPTAGS U>nbr H_VCAS 2DROP 4UNROLL3DROP SWAP ( recompute M with found altitude and inputted VCAS)
		4PICK STRIPTAGS H_Mach 5DROP SWAP ( recompute VCAS with found altitude and inputted Mach)
		SIX  #1-{}N     ( Compose a list of all computed stuff for this combination of altitude and CAS)
	                 ( By inspection it will be verified if there are any problems)
	 %2 xRND         ( Round to the second decimal digit to ease inspection)
;
